<?php
  /**
   * Fonctions diverses utilises par le module meteo_channel
   *
   // -------------------------------------------------------------------------//
   * written by: jmsixt<br />
   * Author site: {@link http://jmsixt.free.fr/cms} <br />
   * More information at {@link http://modules.npds.org}<br />
   * Support site: {@link http://trac2.assembla.com/npds_meteochannel/wiki}
   *
   // -------------------------------------------------------------------------//
   * Reference: meteo_channel {@link http://www.meteo_channel.fr} <br />
   *
   // -------------------------------------------------------------------------//
   * This program is free software. you can redistribute it and/or modify <br />
   * it under the terms of the GNU General Public License as published by <br />
   * the Free Software Foundation; either version 2 of the License. <br />
   * @copyright Copyright (c) 2008, Sixt Jean Marc <br />
   *
   // -------------------------------------------------------------------------//
   * @package meteo_channel
   * @author Sixt Jean-Marc from Lyon (2008)
   */
   
  // ==========================================================================================================================================================
  /**
  * Fonction principale de mise en forme du bloc mto
  *
  * gnration du code html pour le contenu mto du bloc<br />
  * principe: suivant que l'utilisateur est logg ou non on rcupre les paramtres dans
  * - meteo_channel_conf.php<br/>
  * - ou dans la table meteo_channel
  *
  * Toutes les rsultats des requtes au serveur weatherchannel sont cachs dans le rpertoire cache
  *
  * @param string $oper ordre  traiter: query, gettown ou centerBloc
  * @return string code html du contenu du bloc
  */    
  function meteo_channel($oper)
  {
      global $modulerep, $user, $op, $lang_meteo_channel, $NPDS_Prefix;
      global $meteo_channel_tooltip, $tooltipstyle;
      global $blockOnly;
      
      $content = "";
      
      // rcupration des donnes de configuration
      // dans le fichier de config
      include("modules/$modulerep/meteo_channel_conf.php");
      // ou dans le profil utilisateur
      if (($meteo_channel_userprofile == "yes") and ($user <> "")) {
          // on met  jour les valeurs de configuration  partir du profil utilisateur s'il est logg et autoris
          // mais seulement si elles sont renseignes
          $usrinfo = getusrinfo($user);
          $uid = $usrinfo["uid"];
          $sql = "select * from " . $NPDS_Prefix . "meteo_channel where uid ='" . $uid . "'";
          $result = sql_query($sql);
          if ($result) {
              if (sql_num_rows($result) == 1) {
                  // on a trouv un enregistrement
                  $row = sql_fetch_assoc($result);
                  
                  if ($row["meteochannel_towncode"] <> "") {
                      $meteochannel_towncode = $row["meteochannel_towncode"];
                  }
                  if ($row["meteochannel_nbjours"] <> "") {
                      $meteochannel_nbjours = $row["meteochannel_nbjours"];
                  }
                  if ($row["meteochannel_townText"] <> "") {
                      $meteochannel_townText = $row["meteochannel_townText"];
                  }
                  if ($row["meteochannel_maincolor"] <> "") {
                      $meteochannel_maincolor = $row["meteochannel_maincolor"];
                  }
                  if ($row["meteochannel_towncolor"] <> "") {
                      $meteochannel_towncolor = $row["meteochannel_towncolor"];
                  }
                  if ($row["meteochannel_backcolor"] <> "") {
                      $meteochannel_backcolor = $row["meteochannel_backcolor"];
                  }
                  if ($row["meteochannel_titlecolor"] <> "") {
                      $meteochannel_titlecolor = $row["meteochannel_titlecolor"];
                  }
                  if ($row["meteochannel_subtitlecolor"] <> "") {
                      $meteochannel_subtitlecolor = $row["meteochannel_subtitlecolor"];
                  }
              }
          }
      } else {
          if ($_COOKIE["meteochannel_towncode"] <> "") {
              $meteochannel_towncode = $_COOKIE["meteochannel_towncode"];
          }
          if (!empty($_COOKIE["meteochannel_townText"])) {
              $meteochannel_townText = $_COOKIE["meteochannel_townText"];
          }
          if (!empty($_COOKIE["meteochannel_nbjours"])) {
              $meteochannel_nbjours = $_COOKIE["meteochannel_nbjours"];
          }
      }
      // On lit systmatiquement 10j pour mettre les informations dans le cache mais on n'affichera que le nombre demand
      if (($meteo_channel_partner == "") or ($meteo_channel_licence == "")) {
          $url = "http://xoap.weather.com/weather/local/" . $meteochannel_towncode . "?cc=*&unit=s&dayf=10";
      } else {
          $url = "http://xoap.weather.com/weather/local/" . $meteochannel_towncode . "?cc=*&unit=s&dayf=10&par=" . $meteo_channel_partner . "&key=" . $meteo_channel_licence;
      }
      // Dbut dfinition des constantes utilises        
      // Style des tootips
      // Style[...]=[TitleColor,TextColor,TitleBgColor,TextBgColor,TitleBgImag,TextBgImag,TitleTextAlign,TextTextAlign, TitleFontFace, TextFontFace, TipPosition, StickyStyle, TitleFontSize, TextFontSize, Width, Height, BorderSize, PadTextArea, CoordinateX , CoordinateY, TransitionNumber, TransitionDuration, TransparencyLevel ,ShadowType, ShadowColor]
      $tooltipstyle = "['white','black','#6487dc','#E8E8FF','','','','','','','center','','','',200,'',2,2,10,10,'','','','','']";
      $tooltipstyle2 = "['white','black','#6487dc','#E8E8FF','','','','','','','sticky','keep','','',200,'',2,2,10,10,'','','','','']";
      
      // Fin dfinition des constantes
      
      // Affichage texte d'intro dans le bloc central
      if ($oper == "centerBloc") {
          echo $meteo_channel_intro . "<br /><br />";
      }
      
      // Affichage de la personnalisation du contenu
      // en fonction des options retenus par l'administration
      if (($meteo_channel_perso == "yes") or (($meteo_channel_userprofile == "yes") and ($user <> "")) or ($oper == "centerBloc")) {
          if ($oper == "centerBloc") {
              $paraconfig .= "<div align=\"center\"><form id=\"form1\" method=\"post\" action=\"modules.php?ModPath=$modulerep&ModStart=mod_param&op=centerBloc\">";
          } else {
              $paraconfig .= "<div align=\"center\"><form id=\"form2\" method=\"post\" action=\"modules.php?ModPath=$modulerep&ModStart=mod_param\">";
          }
          $paraconfig .= tooltipmeteo("Code ville", "Choisissez le code de la ville &agrave; afficher ou cliquez sur le lien aide");
          $paraconfig .= "<input class=\"INPUTA\" type=\"text\" name=\"meteochannel_towncodechange\"  maxlength=\"10\" size=\"10\" value=\"$meteochannel_towncode\" /><a href=\"javascript:AffPopupThenRefresh('modules.php?ModPath=$modulerep&ModStart=meteo_channel&op=gettown','" . meteo_channel_trad("Selection ville") . "','" . meteo_channel_trad("Actualiser la fen&ecirc;tre") . " ?');\"><img src=\"modules/$modulerep/images/aide.gif\" border=\"0\" align=\"absmiddle\" alt=\"Help\" /></a><br />";
          $paraconfig .= tooltipmeteo("Libell&eacute; ville", "Tapez le libell&eacute; &agrave; afficher pour le nom de la ville");
          $paraconfig .= "<input class=\"INPUTA\" type=\"text\" name=\"meteochannel_townTextchange\"  value=\"$meteochannel_townText\" size=\"10\" /><br />";
          $paraconfig .= tooltipmeteo("Nb jours", "Nombre de jours &agrave; afficher");
          $paraconfig .= "<input class=\"INPUTA\" type=\"text\" name=\"meteochannel_nbjourschange\"  value=\"$meteochannel_nbjours\" size=\"3\" /><br />";
          $paraconfig .= "<input name=\"Submit\" type=\"submit\" value=\"ok\" />";
          $paraconfig .= "<input name=\"op\" type=\"hidden\" value=\"$op\" /></form></div>\n";
          if ($meteo_channel_tooltip == "yes") {
              $paraconfig .= "<br /><br />";
          }
          $paraconfig .= "<hr />";
          
          if ($oper == "") {
              $config_bloc = new ToggleDiv(1);
              $tmp_config = $config_bloc->Img();
              $tmp_config .= "<i>" . meteo_channel_trad("Clic pour configurez") . "</i><hr />";
              $content .= $tmp_config;
              $content .= $config_bloc->Begin();
              $content .= $paraconfig;
              $content .= $config_bloc->end();
          } else {
              $content .= $paraconfig;
          }
      }
      // Extraction primaire
      $xml = lit_xml($meteochannel_towncode, $url, true, "day d=.*", array("hi", "low", "part p=\"d\"", "part p=\"n\""));
      
      // Extraction des icones et de l'humidit
      for ($i = 0; $i < $meteochannel_nbjours; $i++) {
          $tmp = preg_split("/<\/?icon>/", $xml["part p=\"d\""][$i]);
          $xml["icond"][$i] = $tmp[1];
          $tmp = preg_split("/<\/?hmid>/", $xml["part p=\"d\""][$i]);
          $xml["hmid"][$i] = $tmp[1];
          $tmp = preg_split("/<\/?icon>/", $xml["part p=\"n\""][$i]);
          $xml["iconn"][$i] = $tmp[1];
      }
      
      $content .= "<style type=\"text/css\"><!--
   .fond { background-color:#$meteochannel_maincolor }
   .corps { background-color:#$meteochannel_backcolor }
   .titre { color: #$meteochannel_titlecolor }
   .sstitre { color: #$meteochannel_subtitlecolor}
   .ville {color: #$meteochannel_towncolor; background-color:#$meteochannel_titlecolor  }
   --></style>";
      
      $content .= "<table class=\"fond\">
   <tr class=\"ville\"><td><center><b>$meteochannel_townText</b></center></td></tr>";
      for ($i = 0; $i < $meteochannel_nbjours; $i++) {
          //  $content .= "<tr><td class=\"corps\"><table><tr><td colspan=\"3\" class=\"sstitre\"><b> " . ucfirst(strftime("%A %d %B %Y",time()+$i*24*3600));
          $content .= "<tr><td class=\"corps\"><table><tr><td colspan=\"3\" class=\"sstitre\"><b> " . datefr(time() + $i * 24 * 3600);
          $content .= "</b></td></tr><tr><td><b>Max:</b> " . (($xml["hi"][$i] == "N/A") ? "N/A" : f2c($xml["hi"][$i])) . "C</td>";
          $content .= "<td class=\"sstitre\">" . meteo_channel_trad("jour") . "</td><td class=\"sstitre\">" . meteo_channel_trad("nuit") . "</td></tr><tr>";
          $content .= "<td><b>Min:</b> " . (($xml["low"][$i] == "N/A") ? "N/A" : f2c($xml["low"][$i])) . "C</td>";
          $content .= "<td rowspan=\"2\"><img src=\"modules/$modulerep/images/" . str_pad($xml["icond"][$i], 2, "0", STR_PAD_LEFT) . ".png\" width=\"40\" /></td>";
          $content .= "<td rowspan=2><img src=\"modules/$modulerep/images/" . str_pad($xml["iconn"][$i], 2, "0", STR_PAD_LEFT) . ".png\" width=\"40\" /></td>";
          $content .= "</tr><tr><td><b>Hygro:</b> " . $xml["hmid"][$i] . "%</td></tr></table></td></tr>";
      }
      $content .= "</table>";
      $content .= "<div align=\"center\">";
      if ($meteo_imgweather == "yes") {
          $content .= "<a href=\"http://www.weather.com\" target=\"_blank\"><img src=\"modules/$modulerep/images/TWClogo_32px.png\" alt=\"The weather channel\" align=\"absmiddle\" border=\"0\" /></a> ";
      }
      $content .= "<a href=\"#\" onclick=\"location.reload(true)\"><img src=\"modules/$modulerep/images/refresh.gif\" alt=\"refresh page\" align=\"absmiddle\" border=\"0\" /></a>";
      if ($meteo_channel_tooltip == "yes") {
          $content .= tooltipmeteo("Raffraichir", "Bouton pour rafraichir la page");
      }
      $content .= "</div>";
      return $content;
  }
  // Conversion Fahrenheit->Celsius
  function f2c($t)
  {
      return round(($t - 32) * 5 / 9);
  }

  // ==========================================================================================================================================================
  /**
  * Affichage d'un tooltip d'aide
  *
  * gnration du code html / javascript pour afficher l'image "?" et le tooltip sur mouseover sur l'image
  *
  * @global bool Affichage ou non des tooltip
  * @global string nom du style des tootips
  * @global string path complet de la racine du module
  * @param string $text texte du contenu du tooltip
  * @param string $title titre du tooltip
  * @return string code html pour dclencher l'affichage du tootip
  */  
  function tooltipmeteo($title, $text)
  {
      global $meteo_channel_tooltip, $tooltipstyle, $modulerep;
      if ($meteo_channel_tooltip == "yes") {
          $trav = "<a href=\"#\" onMouseOver=\"stm(['" . meteo_channel_trad($title) . "','" . meteo_channel_trad($text) . "'],$tooltipstyle)\" onMouseOut=\"htm()\">";
          $trav .= "<img src=\"modules/$modulerep/images/aide.png\" border=\"0\" align=\"absmiddle\" alt=\"Help\" /></a> ";
      } else {
          $trav = "";
      }
      return $trav;
  }
  // ==========================================================================================================================================================
  /**
  * Gnration des layers pour les tooltips d'aide
  *
  * @global string nom du module
  * @return string code html pour dfinir le layer
 */  
  function tooltiplayer($modulerep)
  {
	  $trav = "<div id=\"TipLayer\" style=\"visibility:hidden;position:absolute;z-index:1000;top:-100\"></div>";
	  $trav .=  "<script language=\"JavaScript1.2\" src=\"modules/$modulerep/js/main.js\" type=\"text/javascript\"></script>";
	  $trav .=  "<link rel=\"stylesheet\" href=\"modules/$modulerep/style/dhtmlwindow.css\" type=\"text/css\" />";
	  
	  $trav .=  "<script type=\"text/javascript\" src=\"modules/$modulerep/js/dhtmlwindow.js\">";
	  $trav .=  "/*********************************************** ";
	  $trav .=  "* DHTML Window Widget-  Dynamic Drive (www.dynamicdrive.com)";
	  $trav .=  "* This notice must stay intact for legal use.";
	  $trav .=  "* Visit http://www.dynamicdrive.com/ for full source code";
	  $trav .=  "***********************************************/";
	  $trav .=  "</script>";
	  
	  return $trav;
  }
  
// ==========================================================================================================================================================
/**
* Lecture d'un fichier sans traitement
* @param string $url url du fichier distant  lire
* @return string contenu du fichier lu 
*/  
function readdistantfile($url)
  {
      // Si votre serveur utilise un proxy pour accder  internet
      // renseigner les valeurs ci dessous: on ne gre pas les proxies avec authentification
      // Define a context for HTTP uniquement si on a un proxy sinon  enlevez
      $proxy = "";
      $port = "";
      if ($proxy <> "") {
          $aContext = array('http' => array('proxy' => "$proxy:$port", // This needs to be the server and the port of the NTLM Authentication Proxy Server.
          'request_fulluri' => true, ), );
          $cxContext = stream_context_create($aContext);
          
          // Now all file stream functions can use this context. 
          $contentfile = @file_get_contents($url, false, $cxContext);
      } else {
          // on lit le fichier ou la chane
          $contentfile = @file_get_contents($url);
      }
      return $contentfile;
  }
  
  // ==========================================================================================================================================================
  // Lecture d'un fichier XML
  // et parsing
  function lit_xml($towncode, $chaine, $isFile, $item, $champs)
  {
      // Paramtre pour le cache des donnes lues sur WeatherChannel (obligatoire dans le cadre du contrat de service avec eux)
      //$cache_dir = 'C:\xampp\htdocs\cms\modules\last-fm\cache\\';
      $cache_dir = dirname(__FILE__) . DIRECTORY_SEPARATOR . "cache";
      // Contractual URL Data Returned Refresh Rate 
      // .../weather/local/[loc_id] Head, Loc 12 hours                     43200 s
      // .../weather/local/[loc_id]?cc=* Head, Loc, CC 25 minutes               1500 s
      // .../weather/local/[loc_id]?cc=*&dayf=5 Head, Loc, CC, Forecast 210 minutes (3.5 hours)   12600 s
      // seconds
      $cache_lifetime = 12600;
      
      $file = $cache_dir . DIRECTORY_SEPARATOR . getCacheFileName($towncode);
      
      if (!file_exists($file) || filemtime($file) < time() - $cache_lifetime) {
          //echo "Lecture url et criture: $file";
          $xml = readdistantfile($chaine);
          
          $fp = fopen($file, "w+");
          fwrite($fp, $xml);
          fclose($fp);
      } else {
          //echo "Lecture directe fichier : $file";
          $xml = file_get_contents($file);
      }
      
      if ($xml) {
          // on explode sur <item>
          $tmp = preg_split("/<\/?" . $item . ">/", $xml);
          // pour chaque <item>
          
          $j = sizeof($tmp);
          for ($i = 1; $i < $j; $i++) {
              // on lit les champs demands <champ>
              foreach ($champs as $champ) {
                  $tmp2 = preg_split("/<\/?" . $champ . ">/", $tmp[$i]);
                  // on ajoute au tableau
                  $tmp3[$champ][] = trim(@$tmp2[1]);
              }
          }
          // et on retourne le tableau
          return @$tmp3;
      }
  }
  // ==========================================================================================================================================================
  // Lecture d'un fichier XML
  // et parsing
  function lit_xmlsearch($chaine)
  {
      $xml = readdistantfile($chaine);
      
      if ($xml) {
          // on explode sur <item>
          $tmp = preg_split("/id=\"/", $xml);
          // pour chaque <item>
          for ($i = 1; $i < sizeof($tmp); $i++) {
              // on extrait les infos de chaque rsultats
              $trav = $tmp[$i];
              $tmp2 = preg_split("/\" type/", $tmp[$i]);
              $pos1 = strpos($trav, "\"1\">");
              $pos2 = strpos($trav, "</loc>");
              $tmp3 = substr($trav, $pos1 + 4, $pos2 - $pos1 - 4);
              $res[$i] = array($tmp2[0], $tmp3);
          }
          // et on retourne le tableau
          return @$res;
      }
  }
  // ==========================================================================================================================================================
  function element_attributes($element_name, $xml)
  {
      if ($xml == false) {
          return false;
      }
      // Grab the string of attributes inside an element tag.  
      $found = preg_match('#<' . $element_name . '\s+([^>]+(?:"|\'))\s?/?>#', $xml, $matches);
      if ($found == 1) {
          $attribute_array = array();
          // Match attribute-name attribute-value pairs.  
          $attribute_string = $matches[1];
          $found = preg_match_all('#([^\s=]+)\s*=\s*(\'[^<\']*\'|"[^<"]*")#', $attribute_string, $matches, PREG_SET_ORDER);
          if ($found != 0) {
              // Create an associative array that matches attribute 
              // names to attribute values.  
              foreach ($matches as $attribute) {
                  $attribute_array[$attribute[1]] = $attribute[3];
              }
              return $attribute_array;
          }
      }
      // Attributes either weren't found, or couldn't be extracted 
      // by the regular expression.  
      return false;
  }
  // ==========================================================================================================================================================
  // Date en Franais
  function dateFR($d)
  {
      $m = array("", meteo_channel_trad("Janvier"), meteo_channel_trad("F&eacute;vrier"), meteo_channel_trad("Mars"), meteo_channel_trad("Avril"), meteo_channel_trad("Mai"), meteo_channel_trad("Juin"), meteo_channel_trad("Juillet"), meteo_channel_trad("Aot"), meteo_channel_trad("Septembre"), meteo_channel_trad("Octobre"), meteo_channel_trad("Novembre"), meteo_channel_trad("D&eacute;cembre"));
      $j = array(meteo_channel_trad("Dimanche"), meteo_channel_trad("Lundi"), meteo_channel_trad("Mardi"), meteo_channel_trad("Mercredi"), meteo_channel_trad("Jeudi"), meteo_channel_trad("Vendredi"), meteo_channel_trad("Samedi"));
      $tmp = $j[date("w", $d)] . " " . date("d", $d) . " " . $m[date("n", $d)] . " " . date("Y", $d);
      return $tmp;
  }
  // ==========================================================================================================================================================
  function showPopupMeteo($title, $member, $content)
  {
      global $Default_Theme, $ModPath;
      // dans ces cas on est en mode popup
      if ($cookie[9] == "") {
          $theme = $Default_Theme;
      } else {
          $theme = $cookie[9];
      }
      $content .= "<link href='themes/$theme/style/style.css' title='default' rel='stylesheet' type='text/css' media='all' />";
      include("themes/$theme/theme.php");
      if ($meteo_channel_popuptheme == "yes") {
          fab_block($title, $member, $content, $cache);
      } else {
          echo $content;
      }
      
      echo "<br /><div align=\"center\"><a href=\"javascript:history.back();\"><img src=\"modules/$ModPath/images/back.png\" align=\"absmiddle\" border=\"0\" /> " . meteo_channel_trad("page pr&eacute;c&eacute;dente") . "</div>";
  }
  
  function getCacheFileName($towncode)
  {
      return 'meteochannel-' . $towncode . '.xml';
  }
?>
