<?php
  /**
   * Source principal du module meteo_channel,
   *
   * Prise en compte: <br />
   * - affichage du bloc principal
   * - affichage du bloc de recherche de la meteo pour une ville donne
   *
   // -------------------------------------------------------------------------//
   * written by: jmsixt<br />
   * Author site: {@link http://jmsixt.free.fr/cms} <br />
   * More information at {@link http://modules.npds.org}<br />
   * Support site: {@link http://trac2.assembla.com/npds_meteochannel/wiki}
   *
   // -------------------------------------------------------------------------//
   * Reference: meteo_channel {@link http://www.meteo_channel.fr} <br />
   *
   // -------------------------------------------------------------------------//
   * This program is free software. you can redistribute it and/or modify <br />
   * it under the terms of the GNU General Public License as published by <br />
   * the Free Software Foundation; either version 2 of the License. <br />
   * @copyright Copyright (c) 2008, Sixt Jean Marc <br />
   *
   // -------------------------------------------------------------------------//
   * @package meteo_channel
   * @subpackage main
   * @author Sixt Jean-Marc from Lyon (2008)
   * @version 1.9
   */

   /**
   * Variables globales positionnes par modules.php
   */
  /**
   * Le thme par dfaut utilis dans NPDS
   * @global mixed $Default_Theme
   */
  global $Default_Theme;
  /**
   * La langue utilise par l'utilisateur
   * @global string $language
   */
  global $language;
  /**
   * Le cache global des blocs
   * @global mixed $cache
   */
  global  $cache;
  /**
   * La langue de rcupration des informations de weather channel
   * @global mixed $lang_meteo_channel
   */ 
  global $lang_meteo_channel; 
  /**
   * Le rpertoire principal du module (dtermin automatiquement)
   * @global mixed $modulerep
   */
  global $modulerep;

  // For More security
  if (!eregi("modules.php", $PHP_SELF)) {
      //die();
  }
  if (strstr($ModPath, "..") || strstr($ModStart, "..") || stristr($ModPath, "script") || stristr($ModPath, "cookie") || stristr($ModPath, "iframe") || stristr($ModPath, "applet") || stristr($ModPath, "object") || stristr($ModPath, "meta") || stristr($ModStart, "script") || stristr($ModStart, "cookie") || stristr($ModStart, "iframe") || stristr($ModStart, "applet") || stristr($ModStart, "object") || stristr($ModStart, "meta")) {
      die();
  }

  if (!function_exists('Mysql_Connexion')) {
      include('mainfile.php');
  }
  
  // Dtermination du nom du module
  $fileinfo = explode(DIRECTORY_SEPARATOR, __FILE__);
  $curfile = end($fileinfo);
  $modulerep = prev($fileinfo);
  
  // Retro compatibilit SABLE
  if (!function_exists("sql_connect")) {
      include("modules/$modulerep/retro-compat/mysql.php");
  }
  // Retro compatibilit SABLE
  
  include_once("lib/togglediv.class.php");
  include_once("modules/$modulerep/lang/$language.php");
  include_once("modules/$modulerep/fcts.php");
  
  // Prparation du layer pour affichage des tooltips
  echo tooltiplayer($modulerep);
  
  /**
  * langue utilis pour les liens meteo_channel
  */
  $lang_meteo_channel = meteo_channel_trad($language);
   
  // Initialisation du titre pour la fonction
  global $titre;
  $titre = $title;
  
  // Traitement en fonction du code opration
  switch ($op) {
      // affichage rsultat de recherche      
      case "query":
          $content = "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"6\" class=\"LIGNB\"><tr><td class=\"header\">" . meteo_channel_trad("Choix de la ville &agrave; afficher") . "</td></tr></table><br /><br />";
          
          $url = "http://xoap.weather.com/search/search?where=" . $meteochannel_townText_change;
          
          // Extraction primaire
          $xmltab = lit_xmlsearch($url);
          
          // Affichage liste des choix possibles
          $content .= meteo_channel_trad("Cliquez sur le bouton choisir et mettre &agrave; jour le param&eacute;trage") . "<br />";
          $content .= "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"6\" class=\"LIGNB\">";
          $content .= "<td>" . meteo_channel_trad("Code ville") . "</td><td>" . meteo_channel_trad("Libell&eacute; ville") . "</td><td>Action</td>";
          for ($i = 1; $i <= sizeof($xmltab); $i++) {
              $class = ($i & 1) ? " class=\"LIGNA\"" : " class=\"LIGNB\"";
              $content .= "<tr" . $class . ">";
              $content .= "<td>" . $xmltab[$i][0] . "</td><td>" . $xmltab[$i][1] . "</td>";
              $content .= "<td><form method=\"post\" action=\"modules.php?ModPath=$ModPath&ModStart=mod_param&op=showpopup\"><input name=\"meteochannel_towncodechange\" type=\"hidden\" value=\"" . $xmltab[$i][0] . "\" /><input name=\"meteochannel_townTextchange\" type=\"hidden\" value=\"" . $xmltab[$i][1] . "\" /><input name=\"Submit\" type=\"submit\" value=\"" . meteo_channel_trad("Choisir") . "\" /></form></td></tr>";
          }
          $content .= "</table>";
          
          $title = meteo_channel_trad("Choix ville");
          showPopupMeteo($title, $member, $content);
          
          break;
          
          // affichage formulaire de recherche      
      case "gettown":
          $content = "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"6\" class=\"LIGNB\"><tr><td class=\"header\">" . meteo_channel_trad("D&eacute;termination du code de la ville") . "</td></tr></table><br /><br />";
          
          $content .= "<div align=\"center\"><form method=\"post\" action=\"modules.php?ModPath=$ModPath&ModStart=meteo_channel&op=query\">" . "<table width=\"100%\" border=\"0\">" . "<tr>" . "  <td width=\"100%\">" . "    <table width=\"100%\" border=\"0\">" . "      <tr><td colspan=\"2\">" . meteo_channel_trad("Saisissez le nom de la ville &agrave; rechercher") . "</td></tr><tr>" . "        <td class=\"ligna\">" . meteo_channel_trad("Nom de la ville") . "</td>" . "        <td><input class=\"INPUTA\" type=\"text\" name=\"meteochannel_townText_change\"  value=\"$meteochannel_townText\"   maxlength=\"40\" size=\"20\" /></td>" . "      </tr>" . "      <tr><td colspan=\"3\" align=\"center\"><input name=\"Submit\" type=\"submit\" value=\"" . meteo_channel_trad("Rechercher") . "\" /></td></tr></table>" . "</td></tr></table></form></div>";
          
          $title = meteo_channel_trad("Recherche ville");
          showPopupMeteo($title, $member, $content);
          
          break;
          
          // affichage bloc central avec ou sans bloc de droite      
      case "centerBloc":
          $pdst = 1;
          include("header.php");
          OpenTable();
          echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"6\" class=\"LIGNB\"><tr><td class=\"header\">METEO</td></tr></table><br /><br />";
          echo "<div align=\"center\">";
          echo meteo_channel("$op");
          echo "<hr />";
          // Affichage ventuel du lien admin
          if (autorisation(-127)) {
              echo "<a href=\"admin.php?op=Extend-Admin-SubModule&ModPath=$modulerep&ModStart=admin/adm\">Administration meteo_channel</a>";
          }
          echo "</div>";
          CloseTable();
          include("footer.php");
          break;
          
          
      default:
          if ($op <> "") {
              include("header.php");
              OpenTable();
              echo meteo_channel("$op");
              echo "<hr />";
              // Affichage ventuel du lien admin
              if (autorisation(-127)) {
                  echo "<a href=\"admin.php?op=Extend-Admin-SubModule&ModPath=$modulerep&ModStart=admin/adm\">Administration meteo_channel</a>";
              }
              CloseTable();
              include("footer.php");
          }
          break;
  }
?>
